<?php

/**
 * Categories Controller
 *
 * @link 		https://entusiastics.com
 * @since 		1.0.0
 *
 * @package 	Entusiastics_Quiz_Game
 * @subpackage 	Entusiastics_Quiz_Game/admin/controllers
 */

if( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly


class CategoriesController {

	static function manage() {

		$action = filter_input(INPUT_GET, 'action');

		if(empty($action)){
			return false;
		} 

		switch($action) {
			case 'add':
			self::index();
			break;
			case 'edit': 
			self::edit();
			break;
			case 'delete':
			self::delete();
			break;
			case 'copy':
			self::copy();
			break;
			default:
			self::index(); 
			break;
		}

	} // end manage()
	
	static function index() {

		$request = $_POST;
		$store = filter_input(INPUT_POST, 'ok');
		
		if(!empty($store)) {

			self::save($request);
		}

		include(ENTUSIASTICS_QUIZ_GAME_PLUGIN_PATH.'admin/partials/entusiastics-quiz-game-category.php');

	} // end index

	static function edit() {

		$request = $_POST;
		$quiz_id = filter_input(INPUT_GET, 'id');
		$store = filter_input(INPUT_POST, 'ok');
		
		if(!empty($store)) {
			self::store($request, $quiz_id);
		}

		$_category = new Category();
		
		// select the category
		$category = $_category->getCategoryByQuizzId($quiz_id);

		include(ENTUSIASTICS_QUIZ_GAME_PLUGIN_PATH.'admin/partials/entusiastics-quiz-game-category.php');

	} // end edit

	static function save($request) {

		$_category = new Category();

		try {
			$category_id = $_category->add($request);
			entusiastics_quiz_game_redirect("admin.php?page=entusiastics-quiz-game-categories"); 
			exit;
		}
		catch(Exception $e) {
			$error = $e->getMessage();
		}

	} // end save

	static function store($request, $quiz_id) {

		$_category = new Category();

		try {

			$_category->save($request, $quiz_id);

			entusiastics_quiz_game_redirect("admin.php?page=entusiastics-quiz-game-categories");
		}
		catch(Exception $e) {
			$error = $e->getMessage();
		}		

	} // end edit_type
	

	// list and delete categories
	static function delete() {

		$_category = new Category();

		$_category->delete($_GET['id']);
		
		entusiastics_quiz_game_redirect("admin.php?page=entusiastics-quiz-game-categories");	
		
	} // end list_categories
	
}